#!/usr/bin/perl
package upgrade_ado;
$raq4=1;

sub install_files
{
	my ($sourcedir, $caspdir) = @_;

	#replace ODBC drivers
	system("cp $sourcedir/ivInterBase00.so $caspdir/odbc/opensource/lib");
	system("cp $sourcedir/IscDbc00.so $caspdir/odbc/opensource/lib");       
	system("cp $sourcedir/libmyodbc-2.50.28.so $caspdir/odbc/opensource/lib");

	#replace ADO and ADOX
	system("cp $sourcedir/libchiliado.so $caspdir/lib");
	system("cp $sourcedir/libchiliadox.so $caspdir/lib");

	#copy additions to admin console database
	system("cp $sourcedir/ENGINES.DBF $caspdir/admin/web/");
	system("cp $sourcedir/ATTS.DBF $caspdir/admin/web/");

	#copy test connection executables
	system("cp $sourcedir/testadocon $caspdir/lib/");
	system("cp $sourcedir/testadoconnection $caspdir/lib");

	#copy admin console asp pages
	system("cp $sourcedir/testdsn.asp.sys $caspdir/admin/sys/testdsn.asp");
	system("cp $sourcedir/testdsn.asp.admin $caspdir/admin/web/odbc/testdsn.asp");

	#copy documentation page
	system("cp \"$sourcedir/Ch04-Admin Console-12.htm\" $caspdir/caspdoc/");
}


sub get_enginedirs
{
	my @retval;
	my $caspdir = shift;
	opendir(DIRS, "$caspdir");
	my @filenames = readdir(DIRS);
	closedir(DIRS);

	foreach(@filenames)
	{
		next if (! -d "$caspdir/$_");
		if ($_ =~ /^asp\-apache\-/)
		{
			unshift(@retval, "$caspdir/$_");
		}
			
	}

	return @retval;
}


sub kill_engines
{
	my ($caspdir, $kill)  = @_;	
	my @dirs = get_enginedirs($caspdir);	

	if ($kill == 1)
	{		
		system("killall -9 caspd caspeng admd admeng admdog");
	}
	else
	{
		system("cd $caspdir;./admtool -s");
	}

	foreach (@dirs)
	{
		if ($kill == 1)
		{
			#system("cd $_;./caspctrl stopall");
		}
		else
		{
			system("cd $_;./caspctrl startall");
			#system("cd $caspdir;admtool -s");
		}
				

	}

}		




sub create_symlinks
{
	$caspdir = shift;
	my @dirs = get_enginedirs($caspdir);

	foreach (@dirs)
	{
		if (! -e "$_/testadocon")
		{
			system("ln -s $caspdir/lib/testadocon $_/testadocon");
			system("ln -s $caspdir/lib/testadoconnection $_/testadoconnection");  
		}
	}
}

sub break_symlinks
{
        my $caspdir = shift;
	my @dirs = get_enginedirs($caspdir);	
 
        foreach (@dirs)
        {
                if (-e "$_/testadocon" && -l "$_/testadocon")
                {
                       system("rm -f $_/testadocon");
                       system("rm -f $_/testadoconnection");
                }
        }
}    


sub backup_files
{
	my ($back, $caspdir) = @_;
	$backupdir = "$caspdir/$back";
	if (!-e $backupdir )
	{
		system("mkdir $backupdir");
	}
	
	system("cp $caspdir/odbc/opensource/lib/libmyodbc-2.50.28.so $backupdir");
	system("cp $caspdir/lib/libchiliado.so $backupdir");
	system("cp $caspdir/admin/web/ENGINES.DBF $backupdir");
	system("cp $caspdir/admin/web/ATTS.DBF $backupdir");
	system("cp $caspdir/admin/sys/testdsn.asp $backupdir");
	system("cp \"$caspdir/caspdoc/Ch04-Admin Console-12.htm\" $backupdir");
	
}

sub restore_files
{
	my ($back, $caspdir) = @_;
	my $backupdir = "$caspdir/$back";
	system("cp $backupdir/libmyodbc-2.50.28.so $caspdir/odbc/opensource/lib/");
	system("cp $backupdir/libchiliado.so $caspdir/lib/");
	system("cp $backupdir/ENGINES.DBF $caspdir/admin/web/");
	system("cp $backupdir/ATTS.DBF $caspdir/admin/web/");
	system("cp $backupdir/testdsn.asp $caspdir/admin/sys/");
	system("cp \"$backupdir/Ch04-Admin Console-12.htm\" $caspdir/capdoc/");

}


sub remove_files
{
	my $caspdir = shift;
	system("rm -f $caspdir/lib/libchiliadox.so");
	system("rm -f $caspdir/admin/web/odbc/testdsn.asp");
	system("rm -f $caspdir/lib/testadocon");
	system("rm -f $caspdir/lib/testadoconnection");
}

sub register_controls
{
	my $caspdir = shift;
	system("cd $caspdir/;./chregsvr $caspdir/lib/libchiliado.so");
       	system("cd $caspdir;./chregsvr $caspdir/lib/libchiliadox.so");
}


sub write_log
{
	my ($file,$text)  = @_;
	open(OUT,">>$file\n");
	print OUT $text;
	close OUT;
}

return 1;              
