#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 2.0
# date: 6-25-99
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# Not good to be used in setup wizard
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

### START HARDCODED PATHS
my $Adminuser = 'admin';
my $AlertList = 'sys';
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
use Cobalt::User;
use Cobalt::List;
use Cobalt::Netutil;

use DB_File;
use Fcntl qw(O_RDWR O_CREAT);
# use strict;
use CGI;
use Locale::gettext;

# global variables
my $scriptURL="/cgi-bin/.cobalt/admin/admin.cgi";

my $q=new CGI;

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

# the page that run this script
my $page=$q->param( 'page' );

if( $page eq 'adminmain' ) { handleAdminPage(); }
else {
    genAdminPage( \*STDOUT );
}

1;


#
# event handler for admin page
#
sub handleAdminPage {
    # read form input
    my $fullName=$q->param( 'fullname' );
    my $password1=$q->param( 'password1' );
    my $password2=$q->param( 'password2' );
    my $email=$q->param( 'email' );
    my $err=0;
    my $info='<IMG SRC="/.cobalt/images/bang" ALIGN=CENTER>';

    # error check
    my @passwordInBytes=unpack( 'C*', $password1 );
    my $passwordBadChar=0;
    my ($byte, $nopasswd);
    foreach $byte ( @passwordInBytes ) {
	if( $byte>127 ) { $passwordBadChar=1; last; }
    }

    if( !$fullName ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "noFullName")."\"");
	$err=1;
    }
    #elsif( $fullName=~/\'/o || $fullName=~/\"/o ) {
    elsif( $fullName=~/\"/o ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "noQuotesInFullName")."\"");
	$err=1;
    }
    elsif( ( $password1 && !$password2 ) || ( !$password1 && $password2 ) ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "noPasswords")."\"");
	$err=1;
    }
    elsif( $password1 ne $password2 ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "passwordsNotMatch")."\"");
	$err=1;
    }
    elsif( $passwordBadChar ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "passwordBadChar")."\"");
	$err=1;
    }
    else {
	# everything is fine
	my $ret=user_mod( $Adminuser, $fullName, $password1, 0 );

	if( $ret!~/^2/o ) {
	    $info.=substr( $ret, 4 );
	    $err=1;
	}
	else {
	    # update sys list
            if ($email) {
                $ret=alias_set( $AlertList, $Adminuser, $email );
            }
            else {
                $ret=alias_set( $AlertList, $Adminuser);
            }
	    if( $ret!~/^2/o ) {
		$info.=substr( $ret, 4 ).'<BR>';
		$err=1;
	    }
	}
    }

    if( $err ) {
	genAdminPage( \*STDOUT, $info );
    }
    else {
	print "location: $scriptURL\n\n";	
    }
}

#
# argument 0 is the file handle the page goes to
# argument 1 is the information shown to user
#
sub genAdminPage {
    my ( $handle, $info )=@_;

    my $fullName=( user_show( $Adminuser ) )[ 1 ];
    my @aliases = Cobalt::List::alias_get($AlertList);
    if ($aliases[0] =~ /^[134]\S*\s/) {
	$info.=substr( $aliases[0], 4 ).'<BR>';
	@aliases = ();
    }
    my $email= join ', ', grep +($_ ne $Adminuser), @aliases;

    my $hideFirstLastStart='';
    my $hideFirstLastEnd='';
    if( !$locale->getProperty( 'firstLastName' ) ) {
	$hideFirstLastStart='<!-- ';
	$hideFirstLastEnd=' -->';
    }

    # Read in the template
    open( TEMPLATE, "$Template_dir/admin.tmpl" )
	|| die "Cannot read $Template_dir/admin.tmpl: $!\n";

    print "content-type: text/html\nCache-Control: no-cache\n\n";

    while( <TEMPLATE> ) {
	s/\[ADMINUSER\]/$Adminuser/o;
	s/\[EMAIL\]/$email/o;
	s/\[FULLNAME\]/$fullName/o;
	s/\[HIDEFIRSTLASTEND\]/$hideFirstLastEnd/o;
	s/\[HIDEFIRSTLASTSTART\]/$hideFirstLastStart/o;
	s/\[SCRIPTURL\]/$scriptURL/o;
	s/\[USER_INFO\]/$info/o;

	s/\[str.([^\]]+)\]/eval("\"".Locale::gettext::dgettext("ui", "$1")."\"")/geo;

	print $handle $_;
    }
    close TEMPLATE;
}
