#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 1.0
# date: 7-4-99
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

### START HARDCODED PATHS
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
use Cobalt::swatch;

use strict;
use CGI;
use Locale::gettext;

# global variables
my $q=new CGI;

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }
my $on=$q->param( 'on' );

my $alertState='false';
my $alertLight;
my $defcon = swatch_get_defcon3_all();
if ($defcon) {
    $alertLight='<IMG SRC="/.cobalt/images/a_monitor_blink" BORDER="0">';
} elsif($on) {
    $alertState='true';
    $alertLight='<IMG SRC="/.cobalt/images/a_monitor_on" BORDER="0">';
} else {
    $alertLight='<IMG SRC="/.cobalt/images/a_monitor_off" BORDER="0">';
}

# Read in the template
open( TEMPLATE, "$Template_dir/alertSignal.tmpl" )
    || die "Cannot read $Template_dir/alertSignal.tmpl: $!\n";

print "content-type: text/html\nCache-Control: no-cache\n\n";

while( <TEMPLATE> ) {
    s/\[ALERTLIGHT\]/$alertLight/o;
    s/\[ALERTSTATE\]/$alertState/o;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

    print;
}

close( TEMPLATE );

