#!/usr/bin/perl

# author: Kevin K.M. Chiu , Timothy Stonis
#       Cobalt Networks
# version: 1.0
# date: 8/17/99 
#
# Copyright (C) 1999-2000, Cobalt Networks, Inc
# All rights reserved

### START HARDCODED PATHS
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
require Cobalt::Services;

use CGI;
# use strict;
use Locale::gettext;

# global variables
my $arkeiaScriptURL='/cgi-bin/.cobalt/arkeia/arkeia.cgi';
my $servicesScriptURL='/cgi-bin/.cobalt/services/services.cgi';

my $q=new CGI;

my $page=$q->param( 'page' );

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

if( $page ne 'arkeia' ) { genArkeiaPage( \*STDOUT ); }
else {
    my $err=0;
    my $info='<IMG SRC="/.cobalt/images/bang" ALIGN=CENTER>';

    # read form input
    my $servername=$q->param( 'arkeiaserver' );

    if( $servername && ( $servername=~/\s/ ) ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "ArkeiaServerNotValid")."\"");
	$err=1;
    }
    else {
	my $ret=Cobalt::Services::set_arkeia_servername( $servername );
	if( $ret!~/^2/o ) {
	    $info.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( !$err ) { print "location: $servicesScriptURL\n\n"; }
    else { genArkeiaPage( \*STDOUT, $info ); }
}

1;


#
# argument 0 is the file handle the page goes to
# argument 1 is the infomation shown to user
#
sub genArkeiaPage {
    my ( $handle, $info )=@_;

    my ( $servername )=Cobalt::Services::get_arkeia_servername();

    # Read in the template
    open( TEMPLATE, "$Template_dir/arkeia.tmpl" )
          || die "Cannot read $Template_dir/arkeia.tmpl: $!\n";

    print "content-type: text/html \nCache-Control: no-cache\n\n";
    while( <TEMPLATE> ) {
        s/\[SERVERNAME\]/$servername/o;
        s/\[SCRIPTURL\]/$arkeiaScriptURL/o;
        s/\[SERVICESSCRIPTURL\]/$servicesScriptURL/o;
        s/\[USER_INFO\]/$info/o;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

        print $handle $_;
    }
    close TEMPLATE;
}
