#!/usr/bin/perl

# Backup menu V3
# Copyright 1999 Cobalt Networks Inc
# Duncan Laurie [duncan@cobaltnet.com]

### START HARDCODED PATHS
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Vsite;
use Cobalt::Locale;
use Cobalt::Meta;
use Cobalt::Util;
use CGI;
use strict;
use Locale::gettext;

my $q = new CGI;
my $user = $ENV{"REMOTE_USER"};
my $group = $q->param('group');

$group = $1 if ($ENV{'QUERY_STRING'} =~ /GROUP=([^\#]+)&/);

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

my $UserError='<IMG SRC="/.cobalt/images/bang.gif" ALIGN=CENTER>'.$1 if ($ENV{'QUERY_STRING'} =~ /USERERROR=([^\#]+)#/); 
$UserError='<IMG SRC="/.cobalt/images/yes.gif" ALIGN=CENTER>'.$1 if ($ENV{'QUERY_STRING'} =~ /USERSUCCESS=([^\#]+)#/);

if ($user eq "admin") {
    # admin gets special backup options
    if ($ENV{'QUERY_STRING'} =~ /PERSONAL/) {
	&user_ops();
    } elsif ($group && !($group eq 'admin')) {
	&site_admin_ops();
    } else {
	&admin_ops();
    }
} elsif (siteAdmin($user)) {
    if ($ENV{'QUERY_STRING'} =~ /PERSONAL/) {
	&user_ops();
    } else {
	&site_admin_ops();
    }
} else {
    &user_ops();
}

sub admin_ops {
	my($userOptions,$u,$v,$fqdn,%userMash,$userElement);

	# add admin to the list (not in database)
	my $seluser = MSG_get_ui("backup_user_select");
	$userOptions = "<option value=\"\"> $seluser </option>\n";
        foreach (Cobalt::Meta::query("type" => "users", "keys" => ["name"])) {
            $userMash{$_} = "<option value=\"$_\"> $_ </option>\n";
        }

        foreach $userElement (sort( keys %userMash )) {
            $userOptions .= $userMash{$userElement};
        }

        # Read in the template
        open (TEMPLATE, "$Template_dir/backupmenuA.tmpl")
              || die "Cannot read $Template_dir/backupmenuA.tmpl: $!\n";

        print "content-type: text/html \nCache-Control: no-cache\n\n";
        while( <TEMPLATE> ) {
            # Do our substitutions
	    s/\[GROUP\]/$group/;
            s/\[USER_LIST\]/$userOptions/;
	    s/\[USERERROR\]/$UserError/;

	    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;

            # Write out the form...
            print;
        }
        close TEMPLATE;
}

sub site_admin_ops {
    my ($userOptions,@users,$userOptions);
   
    @users = vsite_get_users($group);

    my $seluser = MSG_get_ui("backup_user_select");
    $userOptions = "<option value=\"\"> $seluser </option>\n";
    foreach (sort @users) {
	$userOptions .= "<option value=\"$_\"> $_ </option>\n";
    }
    
    open (TEMPLATE, "$Template_dir/backupmenuSA.tmpl")
	|| die "Cannot read $Template_dir/backupmenuSA.tmpl: $!\n";

    print "content-type: text/html \nCache-Control: no-cache\n\n";
    while( <TEMPLATE> ) {
	s/\[GROUP\]/$group/o;
	s/\[USER_LIST\]/$userOptions/o;
	s/\[USERERROR\]/$UserError/o;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

	print;
    }
    close TEMPLATE;
}

sub user_ops {
    # Read in the template
    open (TEMPLATE, "$Template_dir/backupmenuU.tmpl")
          || die "Cannot read $Template_dir/backupmenuU.tmpl: $!\n";

    print "content-type: text/html \nCache-Control: no-cache\n\n";
    while( <TEMPLATE> ) {
        # Do our substitutions
        s/\[USER\]/$user/o;
	s/\[USERERROR\]/$UserError/o;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

        # Write out the form...
        print;
    }
    close TEMPLATE;

}

sub siteAdmin {
    my $user = shift;

    if (scalar(Cobalt::Meta::query("type"  => "users",
				   "keys"  => ["name"],
				   "where" => ["name", "=", "$user",
					       "and", "admin", "=", "on"]))) {
	return 1;
    } else {
	return 0;
    }
}
