#!/usr/bin/perl

# Scheduled Backup menu V3
# Copyright 1998 Cobalt Networks Inc
# Duncan Laurie [duncan@cobaltnet.com]

use Cobalt::Vsite;
### START HARDCODED PATHS
my $Cron_basedir = '/etc/cron.';
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
use Locale::gettext;
use Cobalt::Util;
use Cobalt::Meta;
use CGI;
use strict;

my $UserError;
my $user = $ENV{"REMOTE_USER"};
my $q = new CGI;

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

if ( $ENV{'QUERY_STRING'} =~ /USERERROR=([^\#]+)#/ ) {
     $UserError = '<IMG SRC="/.cobalt/images/bang.gif" ALIGN=CENTER>'.$1;
}

my(@users,@sites,$u,$userOptions,$siteOptions);
my $crondaily = $Cron_basedir."daily";
my $cronweekly = $Cron_basedir."weekly";
my $cronmonthly = $Cron_basedir."monthly";
my $group = $q->param('group');
my (%args,$resource);
my ($b_complete_sel,$b_config_sel,$b_user_sel,$b_site_sel);
my ($s_never_sel,$s_daily_sel,$s_weekly_sel,$s_monthly_sel);
my ($i_all_sel,$i_31_sel,$i_14_sel,$i_7_sel,$i_2_sel,$i_1_sel);
my ($p_ftp_sel,$p_nfs_sel,$p_smb_sel);

$group=$1 if ($ENV{'QUERY_STRING'} =~ /GROUP=([^\#]+)&/);

$group ||= 'admin';
my $sch = "/scheduled-backup.".$group;
my $cron;

 SWITCH:
{
    if ( -e $crondaily.$sch )     { $s_daily_sel = 'SELECTED'; $cron = $crondaily.$sch; last SWITCH; }
    if ( -e $cronweekly.$sch )    { $s_weekly_sel = 'SELECTED'; $cron = $cronweekly.$sch; last SWITCH; }
    if ( -e $cronmonthly.$sch )   { $s_monthly_sel = 'SELECTED'; $cron = $cronmonthly.$sch; last SWITCH; }
    { $s_never_sel = 'SELECTED'; $cron = ''; }
}

# open the scheduled backup, if one exists
if ($cron) {
    open SCH, $cron || die;
    while (<SCH>)
    {
	next unless /^\# (\w+)=(\S+)/;
	$args{$1} = $2;
    }
    close SCH;
}

# check the info
if ($args{'backupset'}) { 
  SWITCH:
    {
	if ($args{'backupset'} eq 'complete') { $b_complete_sel = 'CHECKED'; last SWITCH; }
	if ($args{'backupset'} eq 'config') { $b_config_sel = 'CHECKED'; last SWITCH; }
	if ($args{'backupset'} eq 'site') { $b_site_sel = 'CHECKED'; last SWITCH; }
	if ($args{'backupset'} eq 'user') { $b_user_sel = 'CHECKED'; last SWITCH; }
    }
}
if ($args{'protocol'}) {
  SWITCH:
    {
	if ($args{'protocol'} eq 'ftp') { $p_ftp_sel = 'SELECTED'; last SWITCH; }
	if ($args{'protocol'} eq 'smb') { $p_smb_sel = 'SELECTED'; last SWITCH; }
	if ($args{'protocol'} eq 'nfs') { $p_nfs_sel = 'SELECTED'; last SWITCH; }
    }
}
if ($args{'increment'}) {
  SWITCH:
    {
	if ($args{'increment'} eq '31') { $i_31_sel = 'SELECTED'; }
	if ($args{'increment'} eq '14') { $i_14_sel = 'SELECTED'; }
	if ($args{'increment'} eq '7') { $i_7_sel = 'SELECTED'; }
	if ($args{'increment'} eq '2') { $i_2_sel = 'SELECTED'; }
	if ($args{'increment'} eq '1') { $i_1_sel = 'SELECTED'; }
    }
} else { $i_all_sel = 'SELECTED'; }

if ($args{'resource'}) { $resource = $args{'resource'}; }

if ($group eq 'admin')
{
    my ($u,$v,$fqdn);

    # add admin to the list
    my $seluser = MSG_get_ui("backup_user_select");
    $userOptions = "<option value=\"\"> $seluser </option>\n";

    foreach (Cobalt::Meta::query("type" => "users", "keys" => ["name"])) {
	if ($args{'target'} eq $_) {
	    $userOptions .= "<option value=\"$_\" SELECTED> $_ </option>\n";
	} else {
	    $userOptions .= "<option value=\"$_\"> $_ </option>\n";
	}
    } 
    
    # Read in the template
    open (TEMPLATE, "$Template_dir/backupmenuS.tmpl")
	|| die "Cannot read $Template_dir/backupmenuS.tmpl: $!\n";
    
    print "content-type: text/html \nCache-Control: no-cache\n\n";
    while( <TEMPLATE> ) {
    # Do our substitutions
	s/\[GROUP\]/$group/o;
	s/\[USER_LIST\]/$userOptions/;
	s/\[SITE_LIST\]/$siteOptions/;
	s/\[USERERROR\]/$UserError/;
	s/\[B_COMPLETE_SEL\]/$b_complete_sel/;
	s/\[B_CONFIG_SEL\]/$b_config_sel/;
	s/\[B_USER_SEL\]/$b_user_sel/;
	s/\[I_ALL_SEL\]/$i_all_sel/;
	s/\[I_31_SEL\]/$i_31_sel/;
	s/\[I_14_SEL\]/$i_14_sel/;
	s/\[I_7_SEL\]/$i_7_sel/;
	s/\[I_2_SEL\]/$i_2_sel/;
	s/\[I_1_SEL\]/$i_1_sel/;
	s/\[P_FTP_SEL\]/$p_ftp_sel/;
	s/\[P_NFS_SEL\]/$p_nfs_sel/;
	s/\[P_SMB_SEL\]/$p_smb_sel/;
	s/\[RESOURCE\]/$resource/;
	s/\[S_NEVER_SEL\]/$s_never_sel/;
	s/\[S_DAILY_SEL\]/$s_daily_sel/;
	s/\[S_WEEKLY_SEL\]/$s_weekly_sel/;
	s/\[S_MONTHLY_SEL\]/$s_monthly_sel/;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;

	# Write out the form...
	print;
    }
    close TEMPLATE;
}
else
{
    @users = vsite_get_users($group);
    my $seluser = MSG_get_ui("backup_user_select");
    $userOptions = "<option value=\"\"> $seluser </option>\n";
    foreach (sort @users) {
	if ($args{'target'} eq $_) {
	    $userOptions .= "<option value=\"$_\" SELECTED> $_ </option>\n";
	} else {
	    $userOptions .= "<option value=\"$_\"> $_ </option>\n";
	}
    }

    # Read in the template
    open (TEMPLATE, "$Template_dir/backupmenuSAS.tmpl")
	|| die "Cannot read $Template_dir/backupmenuSAS.tmpl: $!\n";
    
    print "content-type: text/html \n\n";
    while( <TEMPLATE> ) {
    # Do our substitutions
	s/\[GROUP\]/$group/o;
	s/\[USER_LIST\]/$userOptions/o;
	s/\[SITE_LIST\]/$siteOptions/o;
	s/\[USERERROR\]/$UserError/o;
	s/\[B_SITE_SEL\]/$b_site_sel/o;
	s/\[B_USER_SEL\]/$b_user_sel/o;
	s/\[I_ALL_SEL\]/$i_all_sel/o;
	s/\[I_31_SEL\]/$i_31_sel/o;
	s/\[I_14_SEL\]/$i_14_sel/o;
	s/\[I_7_SEL\]/$i_7_sel/o;
	s/\[I_2_SEL\]/$i_2_sel/o;
	s/\[I_1_SEL\]/$i_1_sel/o;
	s/\[P_FTP_SEL\]/$p_ftp_sel/o;
	s/\[P_NFS_SEL\]/$p_nfs_sel/o;
	s/\[P_SMB_SEL\]/$p_smb_sel/o;
	s/\[RESOURCE\]/$resource/o;
	s/\[S_NEVER_SEL\]/$s_never_sel/o;
	s/\[S_DAILY_SEL\]/$s_daily_sel/o;
	s/\[S_WEEKLY_SEL\]/$s_weekly_sel/o;
	s/\[S_MONTHLY_SEL\]/$s_monthly_sel/o;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

	# Write out the form...
	print;
    }
    close TEMPLATE;
}    
exit 0;
