#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Microserver
# version: 2.0
# date: 7-2-99
#
# Copyright 1997-1999, Cobalt Networks, Inc
# All rights reserved

### START HARDCODED PATHS
my $Lockdir = '/etc/locks';
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;

# use strict
use CGI;
use Cobalt::Util;
use Locale::gettext;

my $q=new CGI;

my $mainPageURL = '"/.cobalt/sysManage/" TARGET="_top"';

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

my $page=$q->param( 'page' );

if( $page ne 'rebootmain' ) {
    genRebootPage();
}
else {
    handleRebootPage();
}

1;


sub handleRebootPage {
    # Read in the template
    open( TEMPLATE, "$Template_dir/rebooting.tmpl" )
	|| die "Cannot read $Template_dir/rebooting.tmpl: $!\n";

    my $msg = MSG_get_ui("rebooturl", $mainPageURL);

    print "content-type: text/html \nCache-Control: no-cache\n\n";
    while( <TEMPLATE> ) {
	s/\[RETURNURLMSG\]/$msg/o;
	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;
	print;
    }
    close TEMPLATE;

    # Create a monitor lock file to prevent monitor from running
    # while we reboot
    open(MONLOCK,">$Lockdir/monitor");
    close MONLOCK;

    `/sbin/shutdown -r now`;
}

sub genRebootPage {
    open( TEMPLATE, "$Template_dir/reboot.tmpl" )
	|| die "Cannot read $Template_dir/reboot.tmpl: $!\n";

    print "content-type: text/html\nCache-Control: no-cache\n\n";

    while( <TEMPLATE> ) {
	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

	print;
    }

    close( TEMPLATE );
}
