#!/usr/bin/perl

# author: Kevin K.M. Chiu
#         Will DeHaan
#       Cobalt Networks
# version: 2.0
# date: 7-4-99
#
# Copyright (C) 1998-1999, Cobalt Networks, Inc
# All rights reserved

### START HARDCODED PATHS
my $Template_dir = '/usr/admserv/templates';
my %Features = ('networker','1','telnetConfig','1','dhcpd','0','pagebuilder','0','www','1','mx','1','gated','1','dns','1','nfs','0','securetty','1','arkeia','1','atalk','0','fpx','1','siteAdminRedirect','1','users','1','ntp','0','mon_textdb_only','0','search','0','anonFTP','1','specialHomeSkel','0','viewGroups','0','cobaltHomePage','0','warnRootOnly','1','vsites','1','pam','1','discuss','0','docorg','0','groups','1','smb','0','mail','1','nat','0','asp','1','squid','0','autoGenWebUsage','0','cobaltRedirect','0','backups','1','vmachine','1','mon_port_testing','1','viewUsers','0','usersCGIInWizard','1','aspAdmin','1','privatedirs','0','telnetDefault','1','ssl','0','siteManagement','1','adm','1','mgmt','0','bind8','1','throttle','0','personalRedirect','1','webRequests','1','usersAddUser','0','adminRedirect','1','quotas','1','snmp','1','defaultUserNameGen','1','groupdirs','1','proftpd','1');

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
use Cobalt::Services;
use Cobalt::swatch;

# use strict;
use CGI;
use Locale::gettext;

# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# not good for use in setup wizard
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#
# global variables
#
my $scriptURL='/cgi-bin/.cobalt/services/services.cgi';

my $q=new CGI;

my $page=$q->param( 'page' );

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

if( $page ne 'servicesmain' ) {
    genPage( \*STDOUT );
}
else {
    my $result='<IMG SRC="/.cobalt/images/bang" ALIGN=CENTER>';
    my $err=0;
    my $ret;

    my $currentEmailOn=Cobalt::Services::get_mail_server_on();

    my $emailOn=$q->param( 'email' );
    if( $emailOn=~/on/o ) {
	$ret=Cobalt::Services::set_mail_server_on( 1 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_on("smtp");
	$ret=Cobalt::swatch::swatch_set_service_on("pop3");
	$ret=Cobalt::swatch::swatch_set_service_on("imap");
    } else {
	$ret=Cobalt::Services::set_mail_server_on( 0 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_off("smtp");
	$ret=Cobalt::swatch::swatch_set_service_off("pop3");
	$ret=Cobalt::swatch::swatch_set_service_off("imap");
    }

    my $ftpOn=$q->param( 'ftp' );
    if( $ftpOn=~/on/o ) {
	$ret=Cobalt::Services::set_ftp_server_on( 1 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_on("ftp");
    } else {
	$ret=Cobalt::Services::set_ftp_server_on( 0 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_off("ftp");
    }

    my $telnetOn=$q->param( 'telnet' );
    if( $telnetOn=~/on/o ) {
	$ret=set_telnet_server_on( 1 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_on("telnet");
    } else {
	$ret=set_telnet_server_on( 0 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_off("telnet");
    }

    if( $Features{ 'smb' } ) {
	my $smbOn=$q->param( 'smb' );
	if( $smbOn=~/on/o ) { $ret=Cobalt::Services::set_smb_server_on( 1 ); }
	else { $ret=Cobalt::Services::set_smb_server_on( 0 ); }
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( $Features{ 'arkeia' } ) {
        my $arkeiaOn=$q->param( 'arkeia' );
        if( $arkeiaOn=~/on/o ) { $ret=Cobalt::Services::set_arkeia_client_on( 1 ); }
        else { $ret=Cobalt::Services::set_arkeia_client_on( 0 ); }
        if( $ret!~/^2/o ) {
            $result.=substr( $ret, 4 ).'<BR>';
            $err=1;
        }
    }

    if( $Features{ 'aspAdmin' } ) {
        my $aspAdminOn=$q->param( 'aspAdmin' );
        if( $aspAdminOn=~/on/o ) { $ret=Cobalt::Services::set_casp_server_on( 1, 'admin' ); }
        else { $ret=Cobalt::Services::set_casp_server_on( 0, 'admin' ); }
        if( $ret!~/^2/o ) {
            $result.=substr( $ret, 4 ).'<BR>';
            $err=1;
        }
    }

    if( $Features{ 'atalk' } ) {
	my $appleShareOn=$q->param( 'appleshare' );
	if( $appleShareOn=~/on/o ) { $ret=Cobalt::Services::set_atalk_server_on( 1 ); }
	else { $ret=Cobalt::Services::set_atalk_server_on( 0 ); }
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( $Features{ 'snmp' } ) {
	my $snmpOn=$q->param( 'snmp' );
	if( $snmpOn=~/on/o ) {
	    $ret=Cobalt::Services::set_snmp_server_on( 1 );
	    if( $ret!~/^2/o ) {
		$result.=substr( $ret, 4 ).'<BR>';
		$err=1;
	    }
	    $ret=Cobalt::swatch::swatch_set_service_on("snmp");
	} else {
	    $ret=Cobalt::Services::set_snmp_server_on( 0 );
	    if( $ret!~/^2/o ) {
		$result.=substr( $ret, 4 ).'<BR>';
		$err=1;
	    }
	    $ret=Cobalt::swatch::swatch_set_service_off("snmp");
	}
    }

    if( $Features{ 'networker' } ) {
	my $networkerOn=$q->param( 'networker' );
	if( $networkerOn=~/on/o ) { $ret=Cobalt::Services::set_networker_client_on( 1 ); }
	else { $ret=Cobalt::Services::set_networker_client_on( 0 ); }
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( $Features{ 'dns' } ) {
	my $dnsOn=$q->param( 'dns' );
	if( $dnsOn=~/on/o ) {
	    $ret=Cobalt::Services::set_dns_server_on( 1 );
	    if( $ret!~/^2/o ) {
		$result.=substr( $ret, 4 ).'<BR>';
		$err=1;
	    }
	    $ret=Cobalt::swatch::swatch_set_service_on("dns");
	} else {
	    $ret=Cobalt::Services::set_dns_server_on( 0 );
	    if( $ret!~/^2/o ) {
		$result.=substr( $ret, 4 ).'<BR>';
		$err=1;
	    }
	    $ret=Cobalt::swatch::swatch_set_service_off("dns");
	}
    }

    if( $Features{ 'dhcpd' } ) {
	my $dhcpOn=$q->param( 'dhcp' );
	if( $dhcpOn=~/on/o ) { $ret=Cobalt::Services::set_dhcp_server_on( 1 ); }
	else { $ret=Cobalt::Services::set_dhcp_server_on( 0 ); }
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( $Features{ 'ntp' } ) {
	my $ntpOn=$q->param( 'ntp' );
	if( $ntpOn=~/on/o ) { $ret=Cobalt::Services::set_ntp_server_on( 1 ); }
	else { $ret=Cobalt::Services::set_ntp_server_on( 0 ); }
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    my $analogreverse=$q->param( 'analog');
    if( $analogreverse=~/on/o){
        $ret=Cobalt::Services::set_analog_reverse_on( 1 );
    }
    else
    {
        $ret=Cobalt::Services::set_analog_reverse_on( 0 );
    }
    if( $ret!~/^2/o ) {
        $result.=substr( $ret, 4 ). '<BR>';
        $err=1;
    }

    if( !$err ) {
	genPage( \*STDOUT );
    }
    else {
	genPage( \*STDOUT, $result );
    }
}

1;


#
# argument 0 is the file handle to generate the page to
# argument 1 is the information shown to user
#
sub genPage {
    my( $handle, $info )=@_;

    my $emailChecked=Cobalt::Services::get_mail_server_on()?'CHECKED':'';
    my $ftpChecked=Cobalt::Services::get_ftp_server_on()?'CHECKED':'';
    my $dnsChecked=( $Features{ 'dns' } && Cobalt::Services::get_dns_server_on() )?'CHECKED':'';
    my $telnetChecked=get_telnet_server_on()?'CHECKED':'';
    my $smbChecked=( $Features{ 'smb' } && Cobalt::Services::get_smb_server_on() )?'CHECKED':'';
    my $appleShareChecked=( $Features{ 'atalk' } && Cobalt::Services::get_atalk_server_on() )?'CHECKED':'';
    my $snmpChecked=( $Features{ 'snmp' } && Cobalt::Services::get_snmp_server_on() )?'CHECKED':'';
    my $networkerChecked=( $Features{ 'networker' } && Cobalt::Services::get_networker_client_on() )?'CHECKED':'';
    my $arkeiaChecked=( $Features{ 'arkeia' } && Cobalt::Services::get_arkeia_client_on() )?'CHECKED':'';
    my $dhcpChecked=( $Features{ 'dhcpd' } && Cobalt::Services::get_dhcp_server_on() )?'CHECKED':'';
    my $ntpChecked=( $Features{ 'ntp' } && Cobalt::Services::get_ntp_server_on() )?'CHECKED':'';
    my $analogChecked=( Cobalt::Services::get_analog_reverse_on())?'CHECKED':'';
    my $aspAdminChecked, aspHostname, aspParameters;
    if( $Features{ 'aspAdmin' } ) {
      $aspParameters = '<FONT COLOR=#FFFFFF>&nbsp;</FON>';
      $aspHostname = $ENV{'HTTP_HOST'};
      $aspHostname =~ s/:81//;
      if( Cobalt::Services::get_casp_server_on('admin') ) {
        $aspAdminChecked = 'CHECKED';
        $aspParameters = "<A HREF=\"http://$aspHostname:5100/\" TARGET=NEW>[str.parameters]</A>";
      }   
    }

    my ($arkeiaVersion, $networkerVersion);
    if ($Features{'arkeia'}) {
        `rpm -qv arkeia-client` =~ /^\S+-(.*?)-\d$/;
        $arkeiaVersion = 'v' . $1;
    }

    if ($Features{'networker'}) {
        `rpm -qv lgtoclnt-rh` =~ /^\S+-(.*?)-\d$/;
        $networkerVersion = 'v' . $1;
    }


    # Read in the template
    open( TEMPLATE, "$Template_dir/services.tmpl" )
	|| die "Cannot read $Template_dir/services.tmpl: $!\n";

    print "content-type: text/html\nCache-Control: no-cache\n\n";

    while( <TEMPLATE> ) {
	s/\[EMAILCHECKED\]/$emailChecked/o;
	s/\[FTPCHECKED\]/$ftpChecked/o;
	s/\[TELNETCHECKED\]/$telnetChecked/o;
	s/\[ANALOGCHECKED]/$analogChecked/o;

	if( $Features{ 'discuss' } ) {
	    s/\[HIDEDISCUSSSTART\]//o;
	    s/\[HIDEDISCUSSEND\]//o;
	}
	else {
	    s/\[HIDEDISCUSSSTART\]/<!-- /o;
	    s/\[HIDEDISCUSSEND\]/ -->/o;
	}

	if( $Features{ 'smb' } ) {
	    s/\[SMBCHECKED\]/$smbChecked/o;
	    s/\[HIDESMBSTART\]//o;
	    s/\[HIDESMBEND\]//o;
	}
	else {
	    s/\[HIDESMBSTART\]/<!-- /o;
	    s/\[HIDESMBEND\]/ -->/o;
	}

	if( $Features{ 'atalk' } ) {
	    s/\[APPLESHARECHECKED\]/$appleShareChecked/o;
	    s/\[HIDEATALKSTART\]//o;
	    s/\[HIDEATALKEND\]//o;
	}
	else {
	    s/\[HIDEATALKSTART\]/<!-- /o;
	    s/\[HIDEATALKEND\]/ -->/o;
	}

	if( $Features{ 'snmp' } ) {
	    s/\[SNMPCHECKED\]/$snmpChecked/o;
	    s/\[HIDESNMPSTART\]//o;
	    s/\[HIDESNMPEND\]//o;
	}
	else {
	    s/\[HIDESNMPSTART\]/<!-- /o;
	    s/\[HIDESNMPEND\]/ -->/o;
	}

	if( $Features{ 'networker' } ) {
	    s/\[NETWORKERCHECKED\]/$networkerChecked/o;
	    s/\[NETWORKERVERSION\]/$networkerVersion/o;
	    s/\[HIDENETWORKERSTART\]//o;
	    s/\[HIDENETWORKEREND\]//o;
	}
	else {
	    s/\[HIDENETWORKERSTART\]/<!-- /o;
	    s/\[HIDENETWORKEREND\]/ -->/o;
	}

        if( $Features{ 'arkeia' } ) {
            s/\[ARKEIACHECKED\]/$arkeiaChecked/o;
            s/\[ARKEIAVERSION\]/$arkeiaVersion/o;
            s/\[HIDEARKEIASTART\]//o;
            s/\[HIDEARKEIAEND\]//o;
        }
        else {
            s/\[HIDEARKEIASTART\]/<!-- /o;
            s/\[HIDEARKEIAEND\]/ -->/o;
        }
        
	if( $Features{ 'aspAdmin' } ) {
            s/\[ASPCHECKED\]/$aspAdminChecked/o;
            s/\[HIDEASPADMINSTART\]//o;
            s/\[HIDEASPADMINEND\]//o;
	    s/\[ASPPARAMETER\]/$aspParameters/o;
        }
        else {
            s/\[HIDEASPADMINSTART\]/<!-- /o;
            s/\[HIDEASPADMINEND\]/ -->/o;
        }

	if( $Features{ 'dns' } ) {
	    s/\[DNSCHECKED\]/$dnsChecked/o;
	    s/\[HIDEDNSSTART\]//o;
	    s/\[HIDEDNSEND\]//o;
	}
	else {
	    s/\[HIDEDNSSTART\]/<!-- /o;
	    s/\[HIDEDNSEND\]/ -->/o;
	}

	if( $Features{ 'dhcpd' } ) {
	    s/\[DHCPCHECKED\]/$dhcpChecked/o;
	    s/\[HIDEDHCPDSTART\]//o;
	    s/\[HIDEDHCPDEND\]//o;
	}
	else {
	    s/\[HIDEDHCPDSTART\]/<!-- /o;
	    s/\[HIDEDHCPDEND\]/ -->/o;
	}

	if( $Features{ 'ntp' } ) {
	    s/\[NTPCHECKED\]/$ntpChecked/o;
	    s/\[HIDENTPSTART\]//o;
	    s/\[HIDENTPEND\]//o;
	}
	else {
	    s/\[HIDENTPSTART\]/<!-- /o;
	    s/\[HIDENTPEND\]/ -->/o;
	}

	s/\[USER_INFO\]/$info/o;
	s/\[SCRIPTURL\]/$scriptURL/o;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

	print $handle $_;
    }
    close TEMPLATE;
}
