#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 2.0
# date: 7-4-99
#
# Copyright (C) 1999-2000, Cobalt Networks, Inc
# All rights reserved

### START HARDCODED PATHS
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
require Cobalt::Services;

use CGI;
# use strict;
use Locale::gettext;

# global variables
my $snmpScriptURL='/cgi-bin/.cobalt/snmp/snmp.cgi';
my $servicesScriptURL='/cgi-bin/.cobalt/services/services.cgi';

my $q=new CGI;

my $page=$q->param( 'page' );

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

if( $page ne 'snmp' ) { genSNMPPage( \*STDOUT ); }
else {
    my $err=0;
    my $info='<IMG SRC="/.cobalt/images/bang" ALIGN=CENTER>';

    # read form input
    my $readCommunity=$q->param( 'readcommunity' );
    my $readWriteCommunity=$q->param( 'readwritecommunity' );

    if( $readCommunity && ( $readCommunity=~/\s/ ) ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "readCommunityNotValid")."\"");
	$err=1;
    }
    elsif( $readWriteCommunity && ( $readWriteCommunity=~/\s/ ) ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "readWriteCommunityNotValid")."\"");
	$err=1;
    }
    elsif( $readCommunity eq $readWriteCommunity ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "communityNotUnique")."\"");
	$err=1;
    }
    else {
	my $ret=Cobalt::Services::set_snmp_community( $readCommunity, $readWriteCommunity );
	if( $ret!~/^2/o ) {
	    $info.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( !$err ) { print "location: $servicesScriptURL\n\n"; }
    else { genSNMPPage( \*STDOUT, $info ); }
}

1;


#
# argument 0 is the file handle the page goes to
# argument 1 is the infomation shown to user
#
sub genSNMPPage {
    my ( $handle, $info )=@_;

    my ( $readCommunity, $readWriteCommunity )=Cobalt::Services::get_snmp_community();

    # Read in the template
    open( TEMPLATE, "$Template_dir/snmp.tmpl" )
          || die "Cannot read $Template_dir/snmp.tmpl: $!\n";

    print "content-type: text/html \nCache-Control: no-cache\n\n";
    while( <TEMPLATE> ) {
        s/\[READCOMMUNITY\]/$readCommunity/o;
        s/\[SCRIPTURL\]/$snmpScriptURL/o;
        s/\[SERVICESSCRIPTURL\]/$servicesScriptURL/o;
        s/\[READWRITECOMMUNITY\]/$readWriteCommunity/o;
        s/\[USER_INFO\]/$info/o;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

        print $handle $_;
    }
    close TEMPLATE;
}
