#!/usr/bin/perl

#
# works only within personal profile
#
# Copyright (C) 1999-2000, Cobalt Networks, Inc
# All rights reserved

### START HARDCODED PATHS
my $AdminCGIs_dir = '/usr/admserv/cgi-bin/.cobalt';
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
use Cobalt::User;
use Cobalt::Email;
use Cobalt::Meta;

# use strict;
use CGI;
use Locale::gettext;

# global variables
my $q=new CGI;

my $page=$q->param('page');
my $info = ($q->param('err') eq 'yes') ? ("$ENV{'USERERROR'}") : ("");

my $userModScriptDir="$AdminCGIs_dir/userMod/";
my $userModScriptURL='/cgi-bin/.cobalt/userMod/userMod.cgi';

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );

if( $page eq 'usermod' ) { handleUserModPage(); }
else { genUserModPage($info); }

1;

#
# event handler for modify user page
#
sub handleUserModPage {
    my $userName=$ENV{ REMOTE_USER };

    my $err=0;
    my $info='<IMG SRC="/.cobalt/images/bang" ALIGN=CENTER>';

    # read form input
    my $fullName=$q->param( 'fullname' );
    my $altName=$q->param( 'altname' );
    my $password1=$q->param( 'password1' );
#    my $password2=$q->param( 'password2' );

    # error check
    my @passwordInBytes=unpack( 'C*', $password1 );
    my $passwordBadChar=0;
    my $byte;
    foreach $byte ( @passwordInBytes ) {
	if( $byte>127 ) { $passwordBadChar=1; last; }
    }

    if( !$fullName ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "noFullName")."\"");
	$err=1;
    }
#    elsif( $password1 ne $password2 ) {
#	$info.='Passwords entered in the password fields does not match.';
#	$err=1;
#    }
#    elsif( $userName=~/\s/o ) {
#	$info.='No space allowed in user name.';
#	$err=1;
#    }
    elsif( $passwordBadChar ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "passwordBadChar")."\"");
	$err=1;
    }
    elsif( $fullName=~/\'/o || $fullName=~/\"/o ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "noQuotesInFullName")."\"");
	$err=1;
    }
    else {
	# everything is fine

	my $ret=user_mod( $userName, $fullName, $password1 );
	if( $ret!~/^2/o ) {
	    $info.=substr( $ret, 4 );
	    $err=1;
	}

	my @change = ("fullname","$fullName");
	if ($locale->getProperty("altname")) {
	    push @change, ("altname","$altName");
	}
	$ret=Cobalt::Meta::update("type" => "users",
				  "change" => \@change,
				  "where" => ["name","=","$userName"]);

	if ((my $fn_enc=$locale->getProperty("fullname_enc"))) {
	    $ret=Cobalt::User::user_fullname_enc($userName,$fn_enc);
	}

	# update the APOP data base if they changed their password
	my $apop = mail_apop_isuser($userName);
	if ($password1 ne '' && $apop) {
	    $ret=mail_apop_adduser ($userName, $password1);
	    if( $ret!~/^2/o ) {
		$info.=substr( $ret, 4 );
		$err=1;
	    }
	}

    }

    if($err) {
	$ENV{"USERERROR"}="$info";
	print "location: /cgi-bin/.cobalt/userMod/userMod.cgi?err=yes\n\n";
    } else {
	print "location: /cgi-bin/.cobalt/userMod/userMod.cgi\n\n";
    }
}

#
# argument 0 is the infomation shown to user
#
sub genUserModPage {
    my ($info)=@_;

    my $userName=$ENV{ REMOTE_USER };

    my $userObj = Cobalt::Meta->new("type" => "users");
    $userObj->retrieve("$userName");

    my $full=$userObj->get("fullname");
    my $fullName="$full";

    my ($altname,$begin_altname,$end_altname);
    if ($locale->getProperty("altname")) {
	my $alt = $userObj->get("altname");
	$altname = "$alt";
	$begin_altname = "-->";
	$end_altname = "<!--";
    }

    # Read in the template
    open( TEMPLATE, "$Template_dir/userMod.tmpl" )
	|| die "Cannot read $Template_dir/userMod.tmpl: $!\n";

    print "content-type: text/html\nCache-Control: no-cache\n\n";

    while( <TEMPLATE> ) {
	s/\[ALTNAME\]/$altname/o;
	s/\[ALTNAME_BEGIN\]/$begin_altname/o;
	s/\[ALTNAME_END\]/$end_altname/o;
	s/\[FULLNAME\]/$fullName/o;
	s/\[USER_INFO\]/$info/o;
	s/\[USERMODSCRIPTURL\]/$userModScriptURL/go;
	s/\[USERNAME\]/$userName/go;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

	print;
    }
    close TEMPLATE;
}
